function load_scale()
{
  window.scale = null;
  
  function setScale()
  {
    // create scale if not already existing
    if (!scale)
    {
      var noprint_div = document.querySelector(".noprint");
      scale = document.createElement("img");
      scale.className = "control-scale";
      noprint_div.appendChild(scale);
      
      // make it non-draggable
      scale.draggable = false;                                      /* IE10, modern browsers */

      EventUtil.addHandler(scale, "dragstart", function(e, target)  /* IE7-9, older browsers */
      {
        EventUtil.preventDefault(e);
      });      
    }
  
    var LatLon = m.getCenter().toWGS84("LatLon");
    scale.src = "http://mapy.cz/scale?cx=" + LatLon[1] + "&cy=" + LatLon[0] + "&zoom=" + m.getZoom();
    
    // turn off for non-UTM33 maps
    scale.style.display = m.isUTM33() ? "" : "none";
  }
  
  setScale();

  m.getSignals().addListener(window, "map-redraw", function(e, elm)
  {
    setScale();
  });
}

